/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/

#line 1 "makedict.opt"
/* This file is part of GNU Dico.                  -* c -*-
   Copyright (C) 1998-2000, 2008 Sergey Poznyakoff

   GNU Dico is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   GNU Dico is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with GNU Dico.  If not, see <http://www.gnu.org/licenses/>. */

#include <makedict.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <getopt.h>
#include <dico.h>
#include <stdarg.h>
#include <limits.h>

#line 27 "makedict.opt"

#line 27
void print_help(void);
#line 27
void print_usage(void);
#line 65 "makedict.opt"

#line 65
/* Option codes */
#line 65
enum {
#line 65
	_OPTION_INIT=255,
#line 65
	#line 65 "makedict.opt"

#line 65
	OPTION_USAGE,
#line 65 "makedict.opt"

#line 65
	OPTION_VERSION,

#line 65 "makedict.opt"
	MAX_OPTION
#line 65
};
#line 65
static struct option long_options[] = {
#line 65
	#line 30 "makedict.opt"

#line 30
	{ "compile", no_argument, 0, 'c' },
#line 35 "makedict.opt"

#line 35
	{ "dictionary-directory", required_argument, 0, 'd' },
#line 41 "makedict.opt"

#line 41
	{ "kanjidic", required_argument, 0, 'k' },
#line 47 "makedict.opt"

#line 47
	{ "edict", required_argument, 0, 'e' },
#line 53 "makedict.opt"

#line 53
	{ "output-directory", required_argument, 0, 'o' },
#line 59 "makedict.opt"

#line 59
	{ "verbose", no_argument, 0, 'v' },
#line 65 "makedict.opt"

#line 65
	{ "help", no_argument, 0, 'h' },
#line 65 "makedict.opt"

#line 65
	{ "usage", no_argument, 0, OPTION_USAGE },
#line 65 "makedict.opt"

#line 65
	{ "version", no_argument, 0, OPTION_VERSION },

#line 65 "makedict.opt"
	{0, 0, 0, 0}
#line 65
};
#line 65
static struct opthelp {
#line 65
        const char *opt;
#line 65
        const char *arg;
#line 65
        int is_optional;
#line 65
        const char *descr;
#line 65
} opthelp[] = {
#line 65
	#line 32 "makedict.opt"

#line 32
	{ "-c, --compile", NULL, 0, N_("Compile dictionaries using default values.") },
#line 37 "makedict.opt"

#line 37
	{ "-d, --dictionary-directory", N_("DIR"), 0, N_("Set input dictionary path.") },
#line 43 "makedict.opt"

#line 43
	{ "-k, --kanjidic", N_("FILE"), 0, N_("Set name for kanjidic file.") },
#line 49 "makedict.opt"

#line 49
	{ "-e, --edict", N_("FILE"), 0, N_("Set name for edict file.") },
#line 55 "makedict.opt"

#line 55
	{ "-o, --output-directory", N_("DIR"), 0, N_("Set output directory name.") },
#line 61 "makedict.opt"

#line 61
	{ "-v, --verbose", NULL, 0, N_("Increase verbosity level.") },
#line 65 "makedict.opt"

#line 65
	{ NULL, NULL, 0, N_("Other options") },
#line 65 "makedict.opt"

#line 65
	{ "-h, --help", NULL, 0, N_("Give this help list") },
#line 65 "makedict.opt"

#line 65
	{ "--usage", NULL, 0, N_("Give a short usage message") },
#line 65 "makedict.opt"

#line 65
	{ "--version", NULL, 0, N_("Print program version") },

#line 65 "makedict.opt"
};
#line 27 "makedict.opt"

#line 27
const char *program_version = "makedict" " (" PACKAGE_STRING ")";
#line 27
static char doc[] = N_("Create binary dictionary for use with gjdictd.");
#line 27
static char args_doc[] = N_("");
#line 27
const char *program_bug_address = "<" PACKAGE_BUGREPORT ">";
#line 27
		    
#line 27
#define DESCRCOLUMN 30
#line 27
#define RMARGIN 79
#line 27
#define GROUPCOLUMN 2
#line 27
#define USAGECOLUMN 13
#line 27
		    
#line 27
static void
#line 27
indent (size_t start, size_t col)
#line 27
{
#line 27
  for (; start < col; start++)
#line 27
    putchar (' ');
#line 27
}
#line 27
		    
#line 27
static void
#line 27
print_option_descr (const char *descr, size_t lmargin, size_t rmargin)
#line 27
{
#line 27
  while (*descr)
#line 27
    {
#line 27
      size_t s = 0;
#line 27
      size_t i;
#line 27
      size_t width = rmargin - lmargin;
#line 27

#line 27
      for (i = 0; ; i++)
#line 27
	{
#line 27
	  if (descr[i] == 0 || isspace (descr[i]))
#line 27
	    {
#line 27
	      if (i > width)
#line 27
		break;
#line 27
	      s = i;
#line 27
	      if (descr[i] == 0)
#line 27
		break;
#line 27
	    }
#line 27
	}
#line 27
      printf ("%*.*s\n", s, s, descr);
#line 27
      descr += s;
#line 27
      if (*descr)
#line 27
	{
#line 27
	  indent (0, lmargin);
#line 27
	  descr++;
#line 27
	}
#line 27
    }
#line 27
}
#line 27

#line 27
void
#line 27
print_help(void)
#line 27
{
#line 27
  unsigned i;
#line 27
  
#line 27
  printf ("%s %s [%s]... %s\n", _("Usage:"), "makedict", _("OPTION"),
#line 27
	  gettext (args_doc)); 
#line 27
  if (doc && doc[0])
#line 27
    print_option_descr(gettext (doc), 0, RMARGIN);
#line 27
  putchar ('\n');
#line 27

#line 27
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 27
    {
#line 27
      unsigned n;
#line 27
      if (opthelp[i].opt)
#line 27
	{
#line 27
	  n = printf ("  %s", opthelp[i].opt);
#line 27
	  if (opthelp[i].arg)
#line 27
	    {
#line 27
	      char *cb, *ce;
#line 27
	      if (strlen (opthelp[i].opt) == 2)
#line 27
		{
#line 27
		  if (!opthelp[i].is_optional)
#line 27
		    {
#line 27
		      putchar (' ');
#line 27
		      n++;
#line 27
		    }
#line 27
		}
#line 27
	      else
#line 27
		{
#line 27
		  putchar ('=');
#line 27
		  n++;
#line 27
		}
#line 27
	      if (opthelp[i].is_optional)
#line 27
		{
#line 27
		  cb = "[";
#line 27
		  ce = "]";
#line 27
		}
#line 27
	      else
#line 27
		cb = ce = "";
#line 27
	      n += printf ("%s%s%s", cb, gettext (opthelp[i].arg), ce);
#line 27
	    }
#line 27
	  if (n >= DESCRCOLUMN)
#line 27
	    {
#line 27
	      putchar ('\n');
#line 27
	      n = 0;
#line 27
	    }
#line 27
	  indent (n, DESCRCOLUMN);
#line 27
	  print_option_descr (gettext (opthelp[i].descr), DESCRCOLUMN, RMARGIN);
#line 27
	}
#line 27
      else
#line 27
	{
#line 27
	  if (i)
#line 27
	    putchar ('\n');
#line 27
	  indent (0, GROUPCOLUMN);
#line 27
	  print_option_descr (gettext (opthelp[i].descr),
#line 27
			      GROUPCOLUMN, RMARGIN);
#line 27
	  putchar ('\n');
#line 27
	}
#line 27
    }
#line 27
  
#line 27
  putchar ('\n');
#line 27
  print_option_descr (_("Mandatory or optional arguments to long options are also mandatory or optional for any corresponding short options."), 0, RMARGIN);
#line 27
  putchar ('\n');
#line 27
  printf (_("Report bugs to %s.\n"), program_bug_address);
#line 27
}
#line 27

#line 27
void
#line 27
print_usage(void)
#line 27
{
#line 27
  unsigned i;
#line 27
  int f = 0;
#line 27
  unsigned n;
#line 27
  char buf[RMARGIN+1];
#line 27

#line 27
#define FLUSH                        do                                   {                              	  buf[n] = 0;              	  printf ("%s\n", buf);    	  n = USAGECOLUMN;         	  memset (buf, ' ', n);        }                                while (0)
#line 27
#define ADDC(c)   do { if (n == RMARGIN) FLUSH; buf[n++] = c; } while (0)
#line 27

#line 27
  n = snprintf (buf, sizeof buf, "%s %s ", _("Usage:"), "makedict");
#line 27

#line 27
  /* Print a list of short options without arguments. */
#line 27
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 27
    {
#line 27
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 27
	  && opthelp[i].arg == NULL)
#line 27
	{
#line 27
	  if (f == 0)
#line 27
	    {
#line 27
	      ADDC('[');
#line 27
	      ADDC('-');
#line 27
	      f = 1;
#line 27
	    }
#line 27
	  ADDC(opthelp[i].opt[1]);
#line 27
	}
#line 27
    }
#line 27
  if (f)
#line 27
    ADDC(']');
#line 27

#line 27
  /* Print a list of short options with arguments. */
#line 27
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 27
    {
#line 27
      if (opthelp[i].opt && opthelp[i].descr && opthelp[i].opt[1] != '-'
#line 27
	  && opthelp[i].arg)
#line 27
	{
#line 27
	  size_t len = 5 
#line 27
	                + strlen (opthelp[i].arg)
#line 27
			   + (opthelp[i].is_optional ? 2 : 1);
#line 27
	  if (n + len > RMARGIN) FLUSH;
#line 27
	  buf[n++] = ' '; 
#line 27
	  buf[n++] = '['; 
#line 27
	  buf[n++] = '-';
#line 27
	  buf[n++] = opthelp[i].opt[1];
#line 27
	  if (opthelp[i].is_optional)
#line 27
	    {
#line 27
	      buf[n++] = '[';
#line 27
	      strcpy (&buf[n], opthelp[i].arg);
#line 27
	      n += strlen (opthelp[i].arg);
#line 27
	      buf[n++] = ']';
#line 27
	    }
#line 27
	  else
#line 27
	    {
#line 27
	      buf[n++] = ' ';
#line 27
	      strcpy (&buf[n], opthelp[i].arg);
#line 27
	      n += strlen (opthelp[i].arg);
#line 27
	    }
#line 27
	  buf[n++] = ']';
#line 27
	}
#line 27
    }
#line 27

#line 27
  /* Print a list of long options */
#line 27
  for (i = 0; i < sizeof (opthelp) / sizeof (opthelp[0]); i++)
#line 27
    {
#line 27
      if (opthelp[i].opt && opthelp[i].descr)
#line 27
	{
#line 27
	  size_t len;
#line 27
	  const char *longopt;
#line 27

#line 27
	  if (opthelp[i].opt[1] == '-')
#line 27
	    longopt = opthelp[i].opt;
#line 27
	  else if (opthelp[i].opt[2] == ',')
#line 27
	    longopt = opthelp[i].opt + 4;
#line 27
	  else
#line 27
	    continue;
#line 27

#line 27
	  len = 3 + strlen (longopt)
#line 27
	          + (opthelp[i].arg ? 1 + strlen (opthelp[i].arg)
#line 27
		      + (opthelp[i].is_optional ? 2 : 0) : 0);
#line 27
	  if (n + len > RMARGIN) FLUSH;
#line 27
	  buf[n++] = ' '; 
#line 27
	  buf[n++] = '['; 
#line 27
	  strcpy (&buf[n], longopt);
#line 27
	  n += strlen (longopt);
#line 27
	  if (opthelp[i].arg)
#line 27
	    {
#line 27
	      buf[n++] = '=';
#line 27
	      if (opthelp[i].is_optional)
#line 27
		{
#line 27
		  buf[n++] = '[';
#line 27
		  strcpy (&buf[n], opthelp[i].arg);
#line 27
		  n += strlen (opthelp[i].arg);
#line 27
		  buf[n++] = ']';
#line 27
		}
#line 27
	      else
#line 27
		{
#line 27
		  strcpy (&buf[n], opthelp[i].arg);
#line 27
		  n += strlen (opthelp[i].arg);
#line 27
		}
#line 27
	    }
#line 27
	  buf[n++] = ']';
#line 27
	}
#line 27
    }
#line 27
  FLUSH;
#line 27
  
#line 27
}
#line 27

#line 27
const char version_etc_copyright[] =
#line 27
  /* Do *not* mark this string for translation.  %s is a copyright
     symbol suitable for this locale, and %d is the copyright
     year.  */
#line 27
  "Copyright %s 2005, 2006, 2007, 2008 Sergey Poznyakoff";
#line 27

#line 27
void
#line 27
print_version_only(const char *program_version, FILE *stream)
#line 27
{
#line 27
	fprintf (stream, "%s\n", program_version);
#line 27
	/* TRANSLATORS: Translate "(C)" to the copyright symbol
	   (C-in-a-circle), if this symbol is available in the user's
	   locale.  Otherwise, do not translate "(C)"; leave it as-is.  */
#line 27
	fprintf (stream, version_etc_copyright, _("(C)"));
#line 27
	fputc ('\n', stream);
#line 27
}
#line 27

#line 27
void
#line 27
print_version(const char *program_version, FILE *stream)
#line 27
{
#line 27
	print_version_only(program_version, stream);
#line 27
	
#line 27
	fputs (_("License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>\nThis is free software: you are free to change and redistribute it.\nThere is NO WARRANTY, to the extent permitted by law.\n\n"),
#line 27
	       stream);
#line 27
	
#line 27
}
#line 27

#line 65 "makedict.opt"

#line 65


void
get_options (int argc, char *argv[])
{
    
#line 70
 {
#line 70
  int c;
#line 70

#line 70
  while ((c = getopt_long(argc, argv, "cd:k:e:o:vh",
#line 70
                          long_options, NULL)) != EOF)
#line 70
    {
#line 70
      switch (c)
#line 70
        {
#line 70
        default:
#line 70
	   exit(1);
#line 70
	#line 32 "makedict.opt"
	 case 'c':
#line 32
          {
#line 32


#line 33
             break;
#line 33
          }
#line 37 "makedict.opt"
	 case 'd':
#line 37
          {
#line 37

   dictdir = optarg;

#line 39
             break;
#line 39
          }
#line 43 "makedict.opt"
	 case 'k':
#line 43
          {
#line 43

   kanjidict = optarg;

#line 45
             break;
#line 45
          }
#line 49 "makedict.opt"
	 case 'e':
#line 49
          {
#line 49

   edict = optarg;

#line 51
             break;
#line 51
          }
#line 55 "makedict.opt"
	 case 'o':
#line 55
          {
#line 55

   outdir = optarg;

#line 57
             break;
#line 57
          }
#line 61 "makedict.opt"
	 case 'v':
#line 61
          {
#line 61

   verbose++;

#line 63
             break;
#line 63
          }
#line 65 "makedict.opt"
	 case 'h':
#line 65
          {
#line 65

#line 65
		print_help ();
#line 65
                exit (0);
#line 65
	 
#line 65
             break;
#line 65
          }
#line 65 "makedict.opt"
	 case OPTION_USAGE:
#line 65
          {
#line 65

#line 65
		print_usage ();
#line 65
		exit (0);
#line 65
	 
#line 65
             break;
#line 65
          }
#line 65 "makedict.opt"
	 case OPTION_VERSION:
#line 65
          {
#line 65

#line 65
		/* Give version */
#line 65
		print_version(program_version, stdout);
#line 65
		exit (0);
#line 65
         
#line 65
             break;
#line 65
          }

#line 70 "makedict.opt"
        }
#line 70
    }
#line 70
  
#line 70
 }   
#line 70

}
